unit wbrowser;

{$ifdef fpc}
  {$mode objfpc}{$H+}
{$endif}

interface

uses Classes, SysUtils, {$ifdef fpc}SHDocVw_1_1_TLB{$else}SHDocVw{$endif}, ActiveX;

const
DISPID_AMBIENT_USERAGENT = -5513;

type
  //Customizeable-Browser
  TWbrowser = class({$ifdef fpc}TAxcWebBrowser{$else}TWebBrowser{$endif}, IDispatch)
  private




    FDCtlOpts : Integer; //change to cardinal, it was Integer
    procedure SetDCtlOpts(AValue:Integer);


    //IDispatch
    function IDispatch.Invoke = Invoke;
    function Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
      Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult; stdcall;
  public
    Wb:  TWbrowser;
        FUserAgent: string;
    procedure SetUserAgent (const Value: string);

    constructor Create(AOwner: TComponent); override;
    property DCtlOpts : Integer read FDCtlOpts write SetDCtlOpts;

        property UserAgent: string read FUserAgent write SetUserAgent;
  end;

const
DLCTL_DLIMAGES               = $00000010;
DLCTL_VIDEOS                 = $00000020;
DLCTL_BGSOUNDS               = $00000040;
DLCTL_NO_SCRIPTS             = $00000080;
DLCTL_NO_JAVA                = $00000100;
DLCTL_NO_RUNACTIVEXCTLS      = $00000200;
DLCTL_NO_DLACTIVEXCTLS       = $00000400;
DLCTL_DOWNLOADONLY           = $00000800;
DLCTL_NO_FRAMEDOWNLOAD       = $00001000;
DLCTL_RESYNCHRONIZE          = $00002000;
DLCTL_PRAGMA_NO_CACHE        = $00004000;
DLCTL_FORCEOFFLINE           = $10000000;
DLCTL_NO_CLIENTPULL          = $20000000;
DLCTL_NO_BEHAVIORS           = $00008000;
DLCTL_SILENT                  = $40000000;
DLCTL_OFFLINEIFNOTCONNECTED  = $80000000;
DLCTL_OFFLINE               = DLCTL_OFFLINEIFNOTCONNECTED;

DISPID_AMBIENT_DLCONTROL = -5512;

implementation

{$REGION 'TWbrowser-Methods' -fold}

 {
function TWbrowser.Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
  Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult;{$ifdef fpc} stdcall;{$endif}
begin
  if (Flags and DISPATCH_PROPERTYGET <> 0) and (VarResult <> nil) and (DispId = DISPID_AMBIENT_DLCONTROL) then begin
    Result := S_OK;
    case DispID of
      DISPID_AMBIENT_DLCONTROL:  begin
        PVariant(VarResult)^ :=FDCtlOpts;
        //PVariant(VarResult)^ := Integer(DLCTL_NO_JAVA or DLCTL_NO_DLACTIVEXCTLS or DLCTL_NO_RUNACTIVEXCTLS );//or DLCTL_DLIMAGES); //DLCTL_NO_SCRIPTS or
        //PVariant(VarResult)^ := Integer(DLCTL_DOWNLOADONLY or DLCTL_NO_JAVA or DLCTL_NO_SCRIPTS or DLCTL_NO_DLACTIVEXCTLS or DLCTL_NO_RUNACTIVEXCTLS or 0);
      end;
    end;
  end
  else  Result := inherited Invoke(DispID, IID, LocaleID, Flags, Params, VarResult, ExcepInfo, ArgErr);
end;
}


function TWbrowser.Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
  Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult;{$ifdef fpc} stdcall;{$endif}
begin
//check if the DISPID_AMBIENT_USERAGENT flag is being processed and if the User Agent to set is not empty
if (FUserAgent <> '') and (Flags and DISPATCH_PROPERTYGET <> 0) and Assigned(VarResult) and (DispId=DISPID_AMBIENT_USERAGENT) then
begin
//set the user agent
POleVariant(VarResult)^:= FUserAgent+#13#10;
Result := S_OK; //return S_OK
end
else
Result := inherited Invoke(DispID, IID, LocaleID, Flags, Params, VarResult, ExcepInfo, ArgErr); //call the default Invoke method
end;


constructor TWbrowser.Create(AOwner: TComponent);
begin
  FUserAgent:='';
  FDCtlOpts:=DLCTL_NO_DLACTIVEXCTLS or DLCTL_NO_RUNACTIVEXCTLS or DLCTL_NO_JAVA or DLCTL_SILENT or DLCTL_DLIMAGES;
  Inherited Create(AOwner);
end;

procedure TWbrowser.SetUserAgent(const Value: string);
var
  Control: IOleControl;
begin
  FUserAgent := Value;
  //the current interface supports IOleControl?

if DefaultInterface.QueryInterface(IOleControl, Control) = 0 then
   Control.OnAmbientPropertyChange(DISPID_AMBIENT_USERAGENT); //call the OnAmbientPropertyChange event
end;

procedure TWbrowser.SetDCtlOpts(AValue:Integer);
begin
  if FDCtlOpts=AValue then exit;
  FDCtlOpts:=AValue;
  {$ifdef fpc}
  with (OleServer as IOleControl) do begin
    OnAmbientPropertyChange(DISPID_AMBIENT_DLCONTROL);
    _Release;
  end;
  {$else} //Delphi version works
  with (Application as IOleControl) do begin
    OnAmbientPropertyChange(DISPID_AMBIENT_DLCONTROL);
    _Release;
  end;
  {$endif}
end;
{$ENDREGION}


initialization
 {$IFDEF VER150} //d2=VER90 d3=VER100 d4=VER120 d7=VER150 d2006/td=VER180 d2010=VER210
  Set8087CW($133F); //for twebbrowser floating point error up to d7
 {$ENDIF}
  OleInitialize(nil); //for webbrowser keys


finalization
  OleUninitialize; //for webbrowser keys
end.
